-- Philippe lacomme
-- 31 Dec. 2004
-- revised : avril. 2005
-- Ada program example to download an html page from the web
-- Caution.
--
-- This is a demonstration how to use the adasocket library
--
-- Because I am not very font in http protocole, it is possible you expect some trouble
-- with another web server.
--
with Sockets, Text_Io, Sequential_Io;
use Text_Io, Sockets;
procedure Utilise is 
   Sock       : Sockets.Socket_Fd;  
   Port       : Positive          := 80;  
   Un_Fichier : File_Type;  
   package P_Fichier_Code is new Sequential_Io (Character);
   use P_Fichier_Code;
   Un_Fichier2 : P_Fichier_Code.File_Type;  
   package P_Mes_Entiers is new Integer_Io(Integer);
   use P_Mes_Entiers;
   Somme : Natural;  
begin
   Sockets.Socket(Sock, Af_Inet, Sock_Stream);
   -- connection au serveur HTTP
   Connect (Sock, "bermudes.univ-bpclermont.fr", Port);
   -- envoie d'une requete
   Put_Line(Sock, "GET / HTTP/2.0");
   Put_Line(Sock, "Host: bermudes.univ-bpclermont.fr");
   Put_Line(Sock, "Accept: jpg, pictures/gif, pics/jpg, pics/gif, image/x-xbitmap, pics/jpeg,Image/Pjpeg, Image/Png, */*");
      Put_Line(Sock, "");
      Create (Un_Fichier2, Out_File, "c:\rapatrie.html");
      loop
         declare
            Bufferl1 : String := Sockets.Get_Line (Sock);
         begin
            Put_Line("");
            Put_Line(Bufferl1);
            exit when Bufferl1'Length=0;
         end;
      end loop;
      Somme := 0;
      loop
         begin
            declare
               Buffer : String := Sockets.Get (Sock);
               Longueur : Positive;
            begin
               Put("We received "); Put(Buffer'Length); Put(" octects");
               New_Line;
               Somme :=Somme + Buffer'Length;
               for I in 1.. Buffer'Length loop
                  Write(Un_Fichier2,Buffer(I));
               end loop;
            end;
         exception
            when others => exit;
         end;
      end loop;
      Close(Un_Fichier2);
      Shutdown(Sock);
      Put_Line("Connection closed...");
      Put("Total number of octects received : "); Put(Somme); New_Line;
   end Utilise ;
